import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class BombStepper extends PApplet {

// TODO: 

/*
 * A noob programmer's programming exercise <br />
 * Made with Processing <br />
 * Paul (aka. Hsing Liu) April 2012
 */

// Last Update: 8/29/2012


// variables
int setDAS = 9;
boolean zeroARR = true;
boolean sonicDrop = true;
int moveRightKey = KeyEvent.VK_RIGHT;
int moveLeftKey = KeyEvent.VK_LEFT;
int hardDropKey = KeyEvent.VK_SPACE;
int softDropKey = KeyEvent.VK_DOWN;
int rightRotateKey1 = KeyEvent.VK_UP;
// int rightRotateKey2 = 'U';	// TB: 'X' me:'U'
int rightRotateKey2 = 'X';
int leftRotateKey1 = KeyEvent.VK_CONTROL;
// int leftRotateKey2 = 'E';	// TB: 'Z' me: 'E'
int leftRotateKey2 = 'Z';
int holdKey1 = KeyEvent.VK_SHIFT;
// int holdKey2 = 'O';			//  TB: 'C' me: 'O'
int holdKey2 = 'C';
int flipRotateKey = 'I';

int mode = 0;
Button mainPractice, mainOptions, main40L, mainBomb, main18B;
Button optionDAS, optionBack, optionSonicDrop, optionZeroARR,
		optionMoveLeft, optionMoveRight,
		optionLeftRotate1, optionLeftRotate2,
		optionRightRotate1, optionRightRotate2, optionFlip,
		optionHardDrop, optionSoftDrop,
		optionHold1, optionHold2;
Button setKeyBox;
boolean waitClick = false;

boolean[] keys = new boolean[526];
int[][] playField = new int[10][40];
int[][][][] tetromino = {
// 7 tetrominos, each with 4 rotation states, each with 4 minos,
// 	each with 2 coordinates
// int[][][][] tetromino = new int[7][4][4][2];
// I, O, L, J, T, S, Z
{{{0, 0}, {-1, 0}, {1, 0}, {2, 0}},		// I
 {{0, 0}, {0, 1}, {0, -1}, {0, -2}},
 {{0, 0}, {-2, 0}, {-1, 0}, {1, 0}},
 {{0, 0}, {0, -1}, {0, 1}, {0, 2}}},
{{{0, 0}, {0, 1}, {1, 1}, {1, 0}},		// O
 {{0, 0}, {1, 0}, {1, -1}, {0, -1}},
 {{0, 0}, {0, -1}, {-1, -1}, {-1, 0}},
 {{0, 0}, {-1, 0}, {-1, 1}, {0, 1}}},
{{{0, 0}, {-1, 0}, {1, 0}, {1, 1}},		// L
 {{0, 0}, {0, 1}, {0, -1}, {1, -1}},
 {{0, 0}, {-1, -1}, {-1, 0}, {1, 0}},
 {{0, 0}, {-1, 1}, {0, 1}, {0, -1}}},
{{{0, 0}, {-1, 1}, {-1, 0}, {1, 0}},		// J
 {{0, 0}, {1, 1}, {0, 1}, {0, -1}},
 {{0, 0}, {-1, 0}, {1, 0}, {1, -1}},
 {{0, 0}, {-1, -1}, {0, -1}, {0, 1}}},
{{{0, 0}, {-1, 0}, {1, 0}, {0, 1}},		// T
 {{0, 0}, {0, 1}, {0, -1}, {1, 0}},
 {{0, 0}, {0, -1}, {-1, 0}, {1, 0}},
 {{0, 0}, {-1, 0}, {0, -1}, {0, 1}}},
{{{0, 0}, {-1, 0}, {0, 1}, {1, 1}},		// S
 {{0, 0}, {0, 1}, {1, 0}, {1, -1}},
 {{0, 0}, {1, 0}, {0, -1}, {-1, -1}},
 {{0, 0}, {-1, 1}, {-1, 0}, {0, -1}}},
{{{0, 0}, {-1, 1}, {0, 1}, {1, 0}},		// Z
 {{0, 0}, {1, 1}, {1, 0}, {0, -1}},
 {{0, 0}, {-1, 0}, {0, -1}, {1, -1}},
 {{0, 0}, {0, 1}, {-1, 0}, {-1, -1}}}};
int[][][][] kickOffset = {
// 7 tetrominos, each with 4 rotation states, each with 5 offsets,
//	each with 2 coordinates
// int[][][][] kickOffset = new int[7][4][5][2];
{{{0, 0}, {-1, 0}, {2, 0}, {-1, 0}, {2, 0}},		// I
 {{-1, 0}, {0, 0}, {0, 0}, {0, 1}, {0, -2}},
 {{-1, 1}, {1, 1}, {-2, 1}, {1, 0}, {-2, 0}},
 {{0, 1}, {0, 1}, {0, 1}, {0, -1}, {0, 2}}},
{{{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},		// O
 {{0, -1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
 {{-1, -1}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
 {{-1, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}}},
{{{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},		// L
 {{0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2}},
 {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
 {{0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2}}},
{{{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},		// J
 {{0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2}},
 {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
 {{0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2}}},
{{{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},		// T
 {{0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2}},
 {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
 {{0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2}}},
{{{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},		// S
 {{0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2}},
 {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
 {{0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2}}},
{{{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},		// Z
 {{0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2}},
 {{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}},
 {{0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2}}}};
int currentX = 4;
int currentY = 20;
int currentMino = 0;
int currentRotation = 0;
int holdPiece = 9;
int[] pieceSequence = new int[15];

float startTime, timeElapsed;
float inc = 3000;
boolean startPlay = false;	// for moving out the first piece after starting countdown
int totalClears;
int totalPieces;
int totalTetrises, totalTSpins, totalCombos;
int longestCombo;
float bombTimer;
int bombPos;
int totalBombs;

int[] delayShift = {setDAS, setDAS};
boolean hardDropPressed = false;
boolean holdPressed = false;
boolean rightRotatePressed = false;
boolean leftRotatePressed = false;
boolean flipRotatePressed = false;
int lastMoveRotate = 0; // 0 = last move not rotate, 1 = yes, 2 = yes & kicked
int lockCountDown = 60;
int delayLock = 6; 
int gravityTimer = 60;
boolean justHeld = false;
boolean topOut = false;

boolean b2b = false;
int combo = 0;
int score = 0;
String attackName = "";

PFont font;

public void setup() {

	frameRate(60);
	font = loadFont("Helvetica-BoldOblique-40.vlw");
	textAlign(LEFT);
	textFont(font);
	textSize(20);
	size(800, 600);
	background(BGColor);
	ellipseMode(CORNER);

	initializeButtons();

}

public void draw() {

	background(BGColor);

	switch(mode) {
		case 0:
			mainMenu();
			break;
		case 1:
			optionMenu();
			break;
		case 2:
			practiceMode();
			break;
		case 3:
			sprintMode();
			break;
		case 4:
			bombStepper();
			break;
		case 5:
			bombDigRace();
		default:
			break;
	}
}

public void practiceMode() {

	playerInput();
	checkLock();
	checkGravity();
	drawField();
	drawHold();
	drawPreview();
	drawPlayPiece();

	// text displays
	textSize(20);
	fill(50);
	textAlign(LEFT);

	// display attacks
	text(attackName, 550, 500);
	// display score
	text(SCORE, 50, 300);
	text("  " + score, 50, 325);
	// display time elapsed
	timeElapsed = millis() - startTime;
	int min = floor(timeElapsed / (1000*60));
	float sec = (timeElapsed/1000 - (min*60));
	String timeString = min + ":" + nf(sec, 2, 2);
	text(TIMEELAPSED, 50, 250);
	text("  " + timeString, 50, 275);
	// display FPS
	text(nf(frameRate, 2, 1) + " FPS", 50, 550);
	
	// top out, game over
	if (topOut) {
		background(BGColor);
		drawField();
		fill(0);
		textSize(30);
		textAlign(CENTER);
		text(GAMEOVER, 132, 210);
		textSize(18);
		text(PRESSENTER, 132, 260);
		text(TOMAINMENU, 132, 290);
		noLoop();
		mode = 0;
	}
}

public void sprintMode() {

	if (millis() < startTime) {
		drawField();
		drawHold();
		drawPreview();
		textAlign(CENTER);
		textSize(40);
		fill(0);
		text(READY, 400, 250);
		text(ceil((startTime-millis())/1000), 400, 300);
	} else {

		if (!startPlay) {
			startPlay = true;
			nextPiece();
		}

		playerInput();
		if (totalClears < 40) {	// note: some of these may be redundant
			checkLock();
			checkGravity();
		}
		drawField();
		if (totalClears < 40) {
		drawHold();
		drawPreview();
		drawPlayPiece();
		}

		// text displays
		textAlign(CENTER);
		// display time elapsed
		timeElapsed = millis() - startTime;
		int min = floor(timeElapsed / (1000*60));
		float sec = (timeElapsed/1000 - (min*60));
		String timeString = min + ":" + nf(sec, 2, 2);
		textSize(18);
		fill(50);
		text(TIMEELAPSED, 137, 250);
		textSize(30);
		fill(0, 100, 75);
		text(timeString, 137, 283);
		// display lines left
		textSize(18);
		fill(50);
		text(LINESREMAINING, 137, 350);
		textSize(40);
		fill(255, 0, 0);
		text("" + max(0, (40 - totalClears)), 137, 390);
		// display TPM
		textSize(18);
		fill(50);
		text(AVERAGESPEED, 137, 450);
		text(nf(totalPieces*60000/timeElapsed, 1, 1) + " TPM", 137, 475);

		// game over
		if (totalClears >= 40) {		// finished 40L
			//player.close();
			fill(0);
			textSize(30);
			text(GOODJOB, 132, 100);
			textSize(18);
			text(PRESSENTER, 132, 140);
			text(TOMAINMENU, 132, 170);
			noLoop();
		bombPos = (bombPos + 1 + PApplet.parseInt(random(9))) % 10;
		bombRise(bombPos);
			mode = 0;
			topOut = true;
		} else if (topOut) {				// topped out, not done
			//player.close();
			background(BGColor);
			drawField();
			fill(0);
			textSize(30);
			textAlign(CENTER);
			text(GAMEOVER, 132, 210);
			textSize(18);
			text(PRESSENTER, 132, 260);
			text(TOMAINMENU, 132, 290);
			noLoop();
			mode = 0;
		}
	}
}

public void bombStepper() {

	playerInput();
	checkLock();
	checkGravity();
	drawField();
	drawHold();
	drawPreview();
	drawPlayPiece();

	// bomb rising
	if (millis() > bombTimer) {
		// bombTimer is approximately the current time, using it as such
		inc = 720000000/(bombTimer - startTime + 240000);
		//bombTimer +=  (360000000/(bombTimer - startTime + 120000));
		bombTimer += inc;
		// println(inc + " , " + bombTimer);
		bombPos = (bombPos + 1 + PApplet.parseInt(random(9))) % 10;
		bombRise(bombPos);
	}

	// text displays
	textSize(20);
	fill(50);
	textAlign(LEFT);

	// display time elapsed
	timeElapsed = millis() - startTime;
	int min = floor(timeElapsed / (1000*60));
	float sec = (timeElapsed/1000 - (min*60));
	String timeString = min + ":" + nf(sec, 2, 2);
	text(TIMEELAPSED, 50, 250);
	text("  " + timeString, 50, 275);
	// display bomb rising rate
	text(RISERATE, 50, 325);
	float riseRate = 60000/inc;
	text(nf(riseRate,1,1) + " BPM",50,350);
	// display score
	text(SCORE, 50, 400);
	text("  " + score, 50, 425);
	// attack name
	text(attackName, 550, 500);
	
	// top out, game over
	if (topOut) {

		//report stats
		background(BGColor);
		drawField();
		fill(0);
		textSize(30);
		textAlign(CENTER);
		text(GAMEOVER, 132, 100);
		textSize(18);
		text(PRESSENTER, 132, 140);
		text(TOMAINMENU, 132, 170);
		textSize(20);
		fill(50);
		textAlign(LEFT);
		// display time
		timeElapsed = millis() - startTime;
		min = floor(timeElapsed / (1000*60));
		sec = (timeElapsed/1000 - (min*60));
		timeString = min + ":" + nf(sec, 2, 2);
		text(TIME, 50, 250);
		text("  " + timeString, 50, 275);
		// display other left-side stats
		text(SPEED, 50, 300);
		text("  " + nf(totalPieces*60000/timeElapsed, 1, 1) + " TPM", 50, 325);
		text(LINESCLEARED, 50, 350);
		text("  " + totalClears, 50, 375);
		text(BOMBSDETONATED, 50, 400);
		text("  " + totalBombs, 50, 425);
		text(EFFICIENCY, 50, 450);
		float tmp = 100 * totalBombs;
		tmp /= totalPieces;
		text("  " + nf(tmp, 1, 1) + "% Detonations", 50, 475);
		//display right-side stats
		text(SCORE, 575, 175);
		text("  " + score, 575, 200);
		text(ATTACKPERMINUTE, 575, 225);
		tmp = 60000 * score / timeElapsed;
		text("  " + nf(tmp, 1, 1), 575, 250);
		text(ATTACKPERLINE, 575, 275);
		tmp = score;
		if ((totalClears + totalBombs) > 0)
			tmp /= (totalClears + totalBombs);
		else
			tmp = 0;
		text("  " + nf(tmp, 1, 2), 575, 300);
		tmp = score;
		if ((totalClears) > 0)
			tmp /= (totalClears);
		else
			tmp = 0;
		text("(" + nf(tmp, 1, 2) + ")", 645, 300);
		text(TETRISES, 575, 325);
		text("  " + totalTetrises, 575, 350);
		text(TSPINS, 575, 375);
		text("  " + totalTSpins, 575, 400);
		text(TOTALCOMBOS, 575, 425);
		text("  " + totalCombos, 575, 450);
		text(LONGESTCOMBO, 575, 475);
		if (longestCombo < 1)
			longestCombo = 1;
		text("  " + (longestCombo-1), 575, 500);

		noLoop();
		mode = 0;
	}
}

public void bombDigRace() {


	if (millis() < startTime) {
		drawField();
		drawHold();
		drawPreview();
		textAlign(CENTER);
		textSize(40);
		fill(0);
		text(READY, 132, 250);
		text(ceil((startTime-millis())/1000), 132, 300);
	} else {

		if (!startPlay) {
			startPlay = true;
			nextPiece();
		}

		playerInput();
		checkLock();
		checkGravity();
		drawField();
		drawHold();
		drawPreview();
		drawPlayPiece();

		// text displays
		textSize(20);
		fill(50);
		textAlign(LEFT);

		// display time elapsed
		timeElapsed = millis() - startTime;
		int min = floor(timeElapsed / (1000*60));
		float sec = (timeElapsed/1000 - (min*60));
		String timeString = min + ":" + nf(sec, 2, 2);
		text(TIMEELAPSED, 50, 250);
		text("  " + timeString, 50, 275);
		text(PIECESDROPPED, 50, 300);
		text("  " + totalPieces, 50, 325);
		// display score
		text(SCORE, 50, 350);
		text("  " + score, 50, 375);
		// attack name
		text(attackName, 550, 500);
		
		// check if we're done clearing bombs
		boolean hasBomb = false;
		for (int i=0; i<10; i++) {
			if (playField[i][0] == 8)
			hasBomb = true;
		}
		if (hasBomb == false)
			topOut = true;


		if (topOut) {

			// check if we're done clearing bombs
			hasBomb = false;
			for (int i=0; i<10; i++) {
				if (playField[i][0] == 8)
				hasBomb = true;
			}

			//report stats
			background(BGColor);
			drawField();
			fill(0);
			textSize(30);
			textAlign(CENTER);
			text(GAMEOVER, 132, 100);
			textSize(18);
			text(PRESSENTER, 132, 140);
			text(TOMAINMENU, 132, 170);
			textSize(20);
			fill(50);
			textAlign(LEFT);

			if (hasBomb == false) {
				// display time
				timeElapsed = millis() - startTime;
				min = floor(timeElapsed / (1000*60));
				sec = (timeElapsed/1000 - (min*60));
				timeString = min + ":" + nf(sec, 2, 2);
				text(TIME, 50, 250);
				text("  " + timeString, 50, 275);
				// display other left-side stats
				text(PIECESDROPPED, 50, 300);
				text("  " + totalPieces, 50, 325);
				text(SPEED, 50, 350);
				text("  " + nf(totalPieces*60000/timeElapsed, 1, 1) + " TPM", 50, 375);
				text(LINESCLEARED, 50, 400);
				text("  " + totalClears, 50, 425);
				text(SCORE, 575, 250);
				text("  " + score, 575, 275);
				text(ATTACKPERMINUTE, 575, 300);
				float tmp = 60000 * score / timeElapsed;
				text("  " + nf(tmp, 1, 1), 575, 325);
				text(LONGESTCOMBO, 575, 350);
				if (longestCombo < 1)
					longestCombo = 1;
				text("  " + (longestCombo-1), 575, 375);

			}

			noLoop();
			mode = 0;
		}
	}

}

// input handling
public boolean checkKey(int k) {
	if (keys.length >= k) {
		return keys[k];
	}
	return false;
}

public void keyPressed() {
	keys[keyCode] = true;
	// restarting game needs to be done here because of noLoop handling
	if ((checkKey(ENTER) || checkKey(RETURN)) && (topOut)) {
		loop();
	}
	// trap esc key, use or restarting in practice mode
	if (key == ESC) {
		key = 0;
		if (mode == 2){		// Restart Practice
			startTime = millis();
			initializeGame();
			nextPiece();
		}else if (mode == 3){	// Restart 40L
			startTime = millis() + 3000;
			startPlay = false;
			initializeGame();
		} else {
			mode = 0;
		}
	}
	
}

public void keyReleased() {
	keys[keyCode] = false;
}

// drawing elements in game modes

// variables
int colorI = color(44, 209, 255);
int colorO = color(255, 217, 59);
int colorL = color(255, 156, 35);
int colorJ = color(68, 124, 255);
int colorT = color(232, 76, 201);
int colorS = color(134, 234, 57);
int colorZ = color(255, 67, 92);
int colorGh = color(225, 225, 225);	// ghost fill color
int strokeGh = 120;		// ghost stroke color
int colorGb = color(150, 150, 150);	// garbage
int colorB1 = color(100, 100, 100);	// bomb
int colorB2 = color(200, 200, 200);
int colorB3 = color(255, 30, 30);
int BGColor = color(180, 180, 180);	//background color

public void drawField() {
	// draw boxes
	fill(255);
	stroke(0);
	rect(275, 50, 250, 500);  // empty play field

	// draw play field
	fill(0);
	stroke(0);
	for (int i=0; i<10; i++) {
		for (int j=0; j<20; j++) {
			// set fill color & draw them in
			switch(playField[i][j]) {
				case 0:	// I
					fill(colorI);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 1: // O
					fill(colorO);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 2: // L
					fill(colorL);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 3: // J
					fill(colorJ);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 4: // T
					fill(colorT);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 5: // S
					fill(colorS);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 6: // Z
					fill(colorZ);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 7: // garbage
					fill(colorGb);
					rect(275+(25*i), 525-(25*j), 25, 25);
					break;
				case 8: // bomb
					fill(colorB1);
					stroke(0);
					rect(275+(25*i), 525-(25*j), 25, 25);
					fill(colorB2);
					rect(279+(25*i), 529-(25*j), 17, 17);
					fill(colorB3);
					ellipse(282+(25*i), 532-(25*j), 11, 11);
					break;
				default:	// 9 = nothing there
					break;
			}
		}
	}
	drawGrids();
}

public void drawHold() {
	fill(255);
	stroke(0);
	rect(150, 70, 100, 100);	// hold box
	int offset[] = {0, 0};
	if (holdPiece == 0) {
		offset[0] = -13;
		offset[1] = -13;
	} else if (holdPiece == 1) {
		offset[0] = -12;
	}
	drawMino(188+offset[0], 120+offset[1], holdPiece, 0, false);
}

public void drawPreview() {
	fill(255);
	stroke(0);
	rect(550, 50, 100, 400);  // preview box
	int offset[] = {0, 0};
	for (int i=0; i<5; i++) {
		if (pieceSequence[i] == 0) {
			offset[0] = -13;
			offset[1] = -13;
		} else if (pieceSequence[i] == 1) {
			offset[0] = -12;
			offset[1] = 0;
		} else {
			offset[0] = 0;
			offset[1] = 0;
		}
		drawMino(588+offset[0], 100+offset[1]+75*i, pieceSequence[i],
			0, false);
	}
}

public void drawGrids() {
	stroke(220);
	for (int i=300; i<525; i+=25) {
		line (i, 51, i, 549);
	}
	for (int i=75; i<550; i+=25) {
		line (276, i, 524, i);
	}
}

public void drawPlayPiece() {
	
	// draw ghost first, then the tetromino itself
	int ghostY = currentY;
	while(!isOccupied(currentX, ghostY-1, currentMino, currentRotation)) {
		ghostY--;
	}
	drawMino(275+25*currentX, 525-25*ghostY, currentMino, currentRotation,
	true);
	drawMino(275+25*currentX, 525-25*currentY, currentMino, currentRotation,
	false);
}

public void drawMino(int posX, int posY, int minoType, int minoRotation,
		boolean isGhost) {
	if (minoType == 9)
		return;
	if (isGhost) {
		stroke(strokeGh);
		fill(colorGh);
	} else {
		stroke(0);
		switch(minoType) {
			case 0:	// I
				fill(colorI);
				break;
			case 1: // O
				fill(colorO);
				break;
			case 2: // L
				fill(colorL);
				break;
			case 3: // J
				fill(colorJ);
				break;
			case 4: // T
				fill(colorT);
				break;
			case 5: // S
				fill(colorS);
				break;
			case 6: // Z
				fill(colorZ);
				break;
			default:
				break;
		}
	}

	for (int i=0; i<4; i++) {
		int drawPosX = posX + 25*tetromino[minoType][minoRotation][i][0];
		int drawPosY = posY - 25*tetromino[minoType][minoRotation][i][1];
		if (drawPosY >= 50)
			rect(drawPosX, drawPosY, 25, 25);
	}

	// fix play field box after drawing Ghost
	if (isGhost) {
		stroke(0);
		line(275, 50, 525, 50);
		line(275, 50, 275, 550);
		line(525, 50, 525, 550);
		line(275, 550, 525, 550);
	}
}
// Menu, settings, and stats functions

public void mainMenu() {

	main40L.update();
	main40L.draw();
  main18B.update();
  main18B.draw();
	mainBomb.update();
	mainBomb.draw();
	mainPractice.update();
	mainPractice.draw();
	mainOptions.update();
	mainOptions.draw();

	if (mousePressed) {
		if (!waitClick) {
			waitClick = true;

			if (mainOptions.over) {			// Options
				mode = 1;
				setKeyBox.setVal(0);
				setKeyBox.setName("");
			} else if (mainPractice.over) {	// Practice mode
				mode = 2;
				startTime = millis();
				initializeGame();
				nextPiece();
			} else if (main40L.over) {		// 40L mode
				mode = 3;
				startTime = millis() + 3000;
				startPlay = false;
				initializeGame();
			} else if (mainBomb.over) {		// bomb stepping mode
				mode = 4;
				startTime = millis();
				initializeGame();
				bombTimer = startTime + 100;
				nextPiece();
      } else if (main18B.over) {  // 18 bombs mode
        mode = 5;
				startTime = millis() + 3000;
				startPlay = false;
				initializeGame();
        for (int i=0; i<18; i++) {
		      bombPos = (bombPos + 1 + PApplet.parseInt(random(9))) % 10;
		      bombRise(bombPos);
        }
				nextPiece();
        // TODO:  fill this
			}
		}
	} else {
		waitClick = false;
	}
}

public void optionMenu() {

	// Texts
	textAlign(LEFT, CENTER);
	textSize(20);
	text(AUTOSHIFTDELAY, 425, 60 + 15);
	text(SONICDROP, 425, 100 + 15);
	text(INSTANTMOVE, 425, 140 + 15);
	text(MOVELEFT, 425, 180 + 15);
	text(MOVERIGHT, 425, 220 + 15);
	text(ROTATELEFT, 425, 260 + 15);
	text(ROTATERIGHT, 425, 300 + 15);
	text(ROTATE180, 425, 340 + 15);
	text(HARDDROP, 425, 380 + 15);
	text(SOFTDROP, 425, 420 + 15);
	text(HOLD, 425, 460 + 15);
	text(CLICKBOXSETSTO, 190, 530 + 15);

	// check keyboard input and put in setKeyBox
	for (int i=1; i<256; i++) {
		if (keys[i]) {
			setKeyBox.setVal(i);
			setKeyBox.setName("" + keyName(i));
			break;
		}
	}

	// Update & draw buttons
	optionDAS.update();
	optionDAS.draw();
	optionSonicDrop.update();
	optionSonicDrop.draw();
	optionZeroARR.update();
	optionZeroARR.draw();
	optionMoveLeft.update();
	optionMoveLeft.draw();
	optionMoveRight.update();
	optionMoveRight.draw();
	optionLeftRotate1.update();
	optionLeftRotate1.draw();
	optionLeftRotate2.update();
	optionLeftRotate2.draw();
	optionRightRotate1.update();
	optionRightRotate1.draw();
	optionRightRotate2.update();
	optionRightRotate2.draw();
	optionFlip.update();
	optionFlip.draw();
	optionHardDrop.update();
	optionHardDrop.draw();
	optionSoftDrop.update();
	optionSoftDrop.draw();
	optionHold1.update();
	optionHold1.draw();
	optionHold2.update();
	optionHold2.draw();
	optionBack.update();
	optionBack.draw();
	setKeyBox.update();
	setKeyBox.draw();

	// Mouse click events
	if (mousePressed) {
		if (!waitClick) {
			waitClick = true;

			if (optionDAS.over) {					// optionDAS
				if (setDAS <= 3)
					setDAS = 12;
				else
					setDAS--;
				optionDAS.setName("" + setDAS);
			} else if (optionSonicDrop.over) {		// sonicDrop
				sonicDrop = !sonicDrop;
				optionSonicDrop.setName("" + sonicDrop);
			} else if (optionZeroARR.over) {		// zeroARR
				zeroARR = !zeroARR;
				optionZeroARR.setName("" + zeroARR);
			} else if (optionMoveLeft.over) {		// move left
				moveLeftKey = setKeyBox.getVal();
				optionMoveLeft.setName("" + keyName(moveLeftKey));
			} else if (optionMoveRight.over) {		// move right
				moveRightKey = setKeyBox.getVal();
				optionMoveRight.setName("" + keyName(moveRightKey));
			} else if (optionLeftRotate1.over) {	// left rotate 1
				leftRotateKey1 = setKeyBox.getVal();
				optionLeftRotate1.setName("" + keyName(leftRotateKey1));
			} else if (optionLeftRotate2.over) {	// left rotate 2
				leftRotateKey2 = setKeyBox.getVal();
				optionLeftRotate2.setName("" + keyName(leftRotateKey2));
			} else if (optionRightRotate1.over) {	// right rotate 1
				rightRotateKey1 = setKeyBox.getVal();
				optionRightRotate1.setName("" + keyName(rightRotateKey1));
			} else if (optionRightRotate2.over) {	// right rotate 2
				rightRotateKey2 = setKeyBox.getVal();
				optionRightRotate2.setName("" + keyName(rightRotateKey2));
			} else if (optionFlip.over) {			// 180 rotate
				flipRotateKey = setKeyBox.getVal();
				optionFlip.setName("" + keyName(flipRotateKey));
			} else if (optionHardDrop.over) {		// hard drop
				hardDropKey = setKeyBox.getVal();
				optionHardDrop.setName("" + keyName(hardDropKey));
			} else if (optionSoftDrop.over) {		// soft drop
				softDropKey = setKeyBox.getVal();
				optionSoftDrop.setName("" + keyName(softDropKey));
			} else if (optionHold1.over) {			// hold 1
				holdKey1 = setKeyBox.getVal();
				optionHold1.setName("" + keyName(holdKey1));
			} else if (optionHold2.over) {			// hold 2
				holdKey2 = setKeyBox.getVal();
				optionHold2.setName("" + keyName(holdKey2));
			} else if (optionBack.over) {			// Back to menu
				mode = 0;
			}
		}

	} else {
		waitClick = false;
	}

}

public void initializeButtons() {

	int textColor = color(50);
	int baseColor = color(220);
	int highlightColor = color(255);

	// Main menu buttons
	main40L = new Button(260, 70, 280, 100, TEXT40L, 40, textColor,
							baseColor, highlightColor);
	mainBomb = new Button(410, 190, 280, 100, BOMBER, 40, textColor, 
							baseColor, highlightColor);
	main18B = new Button(110, 190, 280, 100, TEXT18B, 40, textColor, 
							baseColor, highlightColor);
	mainPractice = new Button(260, 310, 280, 100, PRACTICE, 40, textColor, 
							baseColor, highlightColor);
	mainOptions = new Button(260, 430, 280, 100, OPTIONS, 40, textColor, 
							baseColor, highlightColor);

	// Option menu buttons
	optionDAS = new Button(225, 60, 75, 30, "" + setDAS, 20, textColor,
							baseColor, highlightColor);
	optionSonicDrop = new Button(225, 100, 75, 30, "" + sonicDrop, 20,
							textColor, baseColor, highlightColor);
	optionZeroARR = new Button(225, 140, 75, 30, "" + zeroARR, 20,
							textColor, baseColor, highlightColor);
	optionMoveLeft = new Button(225, 180, 75, 30, "" + keyName(moveLeftKey),
							20, textColor, baseColor, highlightColor);
	optionMoveRight = new Button(225, 220, 75, 30, "" + keyName(moveRightKey),
							20, textColor, baseColor, highlightColor);
	optionLeftRotate1 = new Button(225, 260, 75, 30, "" + keyName(leftRotateKey1),
							20, textColor, baseColor, highlightColor);
	optionLeftRotate2 = new Button(320, 260, 75, 30, "" + keyName(leftRotateKey2),
							20, textColor, baseColor, highlightColor);
	optionRightRotate1 = new Button(225, 300, 75, 30, "" + keyName(rightRotateKey1),
							20, textColor, baseColor, highlightColor);
	optionRightRotate2 = new Button(320, 300, 75, 30, "" + keyName(rightRotateKey2),
							20, textColor, baseColor, highlightColor);
	optionFlip = new Button(225, 340, 75, 30, "" + keyName(flipRotateKey),
							20, textColor, baseColor, highlightColor);
	optionHardDrop = new Button(225, 380, 75, 30, "" + keyName(hardDropKey),
							20, textColor, baseColor, highlightColor);
	optionSoftDrop = new Button(225, 420, 75, 30, "" + keyName(softDropKey),
							20, textColor, baseColor, highlightColor);
	optionHold1 = new Button(225, 460, 75, 30, "" + keyName(holdKey1),
							20, textColor, baseColor, highlightColor);
	optionHold2 = new Button(320, 460, 75, 30, "" + keyName(holdKey2),
							20, textColor, baseColor, highlightColor);
	optionBack = new Button(580, 525, 120, 40, "Back", 20, textColor,
							baseColor, highlightColor);
	setKeyBox = new Button(370, 530, 75, 30, "", 20, textColor,
							baseColor, highlightColor);

}

class Button {
	int x, y;
	int width, height;
	int textSize;
	int textColor;
	String name;
	int val;
	int currentColor, baseColor, highlightColor;
	boolean over = false;
	boolean pressed = false;

	// constructor
	Button(int ix, int iy, int iwidth, int iheight, String iname,
			int itextSize, int itextColor,
			int ibaseColor, int ihighlightColor) {
		x = ix;
		y = iy;
		width = iwidth;
		height = iheight;
		name = iname;
		textSize = itextSize;
		textColor = itextColor;
		baseColor = ibaseColor;
		highlightColor = ihighlightColor;
	}

	public int getVal() {
		return val;
	}

	public void setVal(int ival) {
		val = ival;
	}

	public void setName(String iname) {
		name = iname;
	}

	public void update() {
		over = over(x, y);
		if (over)
			currentColor = highlightColor;
		else
			currentColor = baseColor;
	}

	public boolean over(int x, int y) {
		if (mouseX >= x && mouseX <= x+width &&
				mouseY >= y && mouseY <= y+height)
			return true;
		else
			return false;
	}

	public void draw() {
		fill(currentColor);
		rect(x, y, width, height);
		fill(textColor);
		textAlign(CENTER, CENTER);
		textSize(textSize);
		text(name, x + width/2 - 1, y + height/2);
	}

}

public String keyName(int keyNum) {
  if (keyNum >= 45 && keyNum <= 93)
    return "" + PApplet.parseChar(keyNum);
  else if (keyNum == 10)
    return "Enter";
  else if (keyNum == 16)
    return "Shift";
  else if (keyNum == 17)
    return "Ctrl";
  else if (keyNum == 18)
    return "Alt";
  else if (keyNum == 32)
    return "Space";
  else if (keyNum == 37)
    return "Left";
  else if (keyNum == 38)
    return "Up";
  else if (keyNum == 39)
    return "Right";
  else if (keyNum == 40)
    return "Down";
  else if (keyNum == 157)
    return "Cmd";
  else
    return "" + keyNum;
}

// game mode mechanics

public void checkLock() {
	// check lock-down
	if (isOccupied(currentX, currentY-1, currentMino, currentRotation)) {
		if (lockCountDown > 0)
				lockCountDown--;
		else
			hardDrop();
	}
}

public void checkGravity() {
	// check gravity
	if (gravityTimer > 0) {
		gravityTimer--;
	} else {
		move(0, -1, false);
	}
}

public void initializeGame() {

	currentX = 4;
	currentY = 20;

	timeElapsed = 0;
	totalClears = 0;
	totalPieces = 0;
	totalBombs = 0;
	totalTetrises = 0;
	totalTSpins = 0;
	totalCombos = 0;
	longestCombo = 0;
  combo = 0;
	score = 0;
	b2b = false;
	topOut = false;
	holdPiece = 9;
	attackName = "";

	// Initialize the playField variable
	for (int i=0; i<10; i++) {
		for (int j=0; j<40; j++) {
			playField[i][j] = 9;
		}
	}

	// Initialize the pieces sequence
	int[] tmp = {0, 1, 2, 3, 4, 5, 6, 0, 1, 2, 3, 4, 5, 6, 9};
	for (int i=0; i<15; i++) {
		pieceSequence[i] = tmp[i];
	}
	generateSequence();		
	for (int i=0; i<7; i++) {
		pieceSequence[i] = pieceSequence[i+7];
	}
	generateSequence();
	// shuffle piece sequence an extra time, for fun
	for (int i=0; i<7; i++) {
		pieceSequence[i] = pieceSequence[i+7];
	}
	generateSequence();
}

public void playerInput() {

	// Hard Drop Key
	if (checkKey(hardDropKey)) {
		if (!hardDropPressed) {
			hardDrop();
		}
		hardDropPressed = true;
	} else
		hardDropPressed = false;

	// Hold Key
	if (checkKey(holdKey1) || checkKey(holdKey2)) {
		if (!holdPressed) {
			hold();
		}
		holdPressed = true;
	} else
		holdPressed = false;

	// Right Rotate Key
	if (checkKey(rightRotateKey1) || checkKey(rightRotateKey2)) {
		if (!rightRotatePressed) {
			rotate(1);
		}
		rightRotatePressed = true;
	} else
		rightRotatePressed = false;

	// Left Rotate Key
	if (checkKey(leftRotateKey1) || checkKey(leftRotateKey2)) {
		if (!leftRotatePressed) {
			rotate(3);
		}
		leftRotatePressed = true;
	} else
		leftRotatePressed = false;

	// 180 Rotate Key
	if (checkKey(flipRotateKey)) {
		if (!flipRotatePressed) {
			rotate(2);
		}
		flipRotatePressed = true;
	} else
		flipRotatePressed = false;
	
	// left and right keys move mino

	if (checkKey(moveLeftKey)) {
		if (delayShift[0] < setDAS) { // left was pressed and not disabled
			if (delayShift[0] == 0)
				move(-1, 0, zeroARR);
			else
				delayShift[0]--;
		} else if (delayShift[0] == setDAS) {	// left previously not pressed
			if (checkKey(moveRightKey)) {	// right was held down
				delayShift[1] = setDAS + 1;		// disable right
			}
			move(-1, 0, false);
			delayShift[0]--;
		}									// otherwise do nothing, disabled
	} else {									// left released/not pressed
		if (delayShift[1] > setDAS) { //right was disabled & pressed. enable it
			delayShift[1] = 8;
		}
		delayShift[0] = setDAS;		// reset left
	}

	if (checkKey(moveRightKey)) {
		if (delayShift[1] < setDAS) { // right was pressed and not disabled
			if (delayShift[1] == 0)
				move(1, 0, zeroARR);
			else
				delayShift[1]--;
		} else if (delayShift[1] == setDAS) {	// right previously not pressed
			if (checkKey(moveLeftKey)) {	// left was held down
				delayShift[0] = setDAS + 1;		// disable left
			}
			move(1, 0, false);
			delayShift[1]--;
		}									// otherwise do nothing, disabled
	} else {									// right released/not pressed
		if (delayShift[0] > setDAS) { //left was disabled & pressed. enable it
			delayShift[0] = 8;
		}
		delayShift[1] = setDAS;		// reset right
	}

	// soft drop
	if (checkKey(softDropKey)) 
		move(0, -1, sonicDrop);
}

public void hardDrop() {

	lockCountDown = 60;
	delayLock = 6;
	gravityTimer = 60;
	justHeld = false;
	totalPieces++;

	// move all the way down
	move(0, -1, true);
	// for bomb mode, check for bomb clears
	if (mode == 4 || mode == 5) {
		for (int i=0; i<4; i++) {
			int checkPosX = currentX +
						tetromino[currentMino][currentRotation][i][0];
			int checkPosY = currentY +
						tetromino[currentMino][currentRotation][i][1] - 1;
			if (checkPosY >= 0) {
				if (playField[checkPosX][checkPosY] == 8) {
					totalBombs++;
					playField[checkPosX][checkPosY] = 7;
				}
			}
		}
	}

	// fill tetromino in the field
	for (int i=0; i<4; i++) {
		int fillPosX = currentX + tetromino[currentMino][currentRotation][i][0];
		int fillPosY = currentY + tetromino[currentMino][currentRotation][i][1];
		playField[fillPosX][fillPosY] = currentMino;
	}

	// check for line clears
	lineClear();

	// reset position and rotation, bring out next piece
	currentX = 4;
	currentY = 20;
	currentRotation = 0;
	nextPiece();
	if (isOccupied(4, 20, currentMino, 0)) {
		topOut = true;
	}
}

public void rotate(int direction) {
	for (int i = 0; i<5; i++) {
		int kickX = currentX +
				kickOffset[currentMino][currentRotation][i][0] -
				kickOffset[currentMino][(currentRotation + direction)%4][i][0];
		int kickY = currentY +
				kickOffset[currentMino][currentRotation][i][1] -
				kickOffset[currentMino][(currentRotation + direction)%4][i][1];
		if ( !isOccupied(kickX, kickY, currentMino,
				(currentRotation+direction)%4)){
			currentX = kickX;
			currentY = kickY;
			currentRotation = (currentRotation + direction) % 4;

			if (i == 0)
				lastMoveRotate = 1;
			else lastMoveRotate = 2;

			break;
		}
	}
	if (lockCountDown < 50) {	// lenient lockdown
		if (delayLock > 0) {
			lockCountDown += 10;
			delayLock--;
		}
	}
}

public void move(int moveX, int moveY, boolean allTheWay) {

	if (!isOccupied(currentX + moveX, currentY + moveY, currentMino,
		currentRotation)) {
			currentX += moveX;
			currentY += moveY;
			lastMoveRotate = 0;
			if (moveY == -1)
				gravityTimer = 60;
	}
	if (allTheWay) {
		while (!isOccupied(currentX + moveX, currentY + moveY, currentMino,
		currentRotation)) {
			currentX += moveX;
			currentY += moveY;
		}
	}
}

public void hold() {
	if (!justHeld) {
		currentX = 4;
		currentY = 20;
		currentRotation = 0;
		if (holdPiece == 9) {
			holdPiece = currentMino;
			nextPiece();
		} else {
			int tmp = holdPiece;
			holdPiece = currentMino;
			currentMino = tmp;
		}
		justHeld = true;
	}
}

public void lineClear() {
	boolean lineFilled;
	boolean wasBomb = false;
	int pcCheck = 0;
	int clearLineCount = 0;

	// t-spin detection
	boolean tSpin;
	int countCorners = 0;
	if (currentMino == 4 && lastMoveRotate > 0) {
		if (currentX + 1 < 0 || currentX + 1 > 9 || currentY + 1 < 0 ||
			currentY + 1 > 39 || playField[currentX+1][currentY+1] != 9)
			countCorners++;
		if (currentX + 1 < 0 || currentX + 1 > 9 || currentY - 1 < 0 ||
			currentY - 1 > 39 || playField[currentX+1][currentY-1] != 9)
			countCorners++;
		if (currentX - 1 < 0 || currentX - 1 > 9 || currentY + 1 < 0 ||
			currentY + 1 > 39 || playField[currentX-1][currentY+1] != 9)
			countCorners++;
		if (currentX - 1 < 0 || currentX - 1 > 9 || currentY - 1 < 0 ||
			currentY - 1 > 39 || playField[currentX-1][currentY-1] != 9)
			countCorners++;
	}
	if (countCorners >= 3)
		tSpin = true;
	else
		tSpin = false;

	// check for filled lines, top to bottom
	for (int j=39; j>=0; j--) {

		lineFilled = true;
		for (int i=0; i<10; i++){
			pcCheck += playField[i][j];
			if ((playField[i][j] > 7)) {	// has bomb or has hole
				lineFilled = false;
			}
		}

		if (lineFilled) {	// clear line and fill down
			if (playField[0][j] < 7) {		//not garbage/bomb line
				clearLineCount++;
				totalClears++;
			} else {
				wasBomb = true;		// is garbage/bomb line
			}
			for (int i=0; i<10; i++){
				pcCheck -= playField[i][j];
			}
			pcCheck += 90;
			for (int k = j; k<39; k++) {
				for (int l=0; l<10; l++) {
					playField[l][k] = playField[l][k+1];
				}
			}
		}
	}

	// score keeping
	if (clearLineCount > 0) {
		attackName = "";

		if (tSpin) {	// T-spin
			totalTSpins++;
			if (b2b)
				attackName = "B2B ";
			if (clearLineCount == 1 && lastMoveRotate == 2) {	// mini
				attackName = attackName + "T-spin mini";
				if (b2b)
					score += 2;
				else
					score += 1;
			} else {
				switch(clearLineCount) {
					case 1:
						attackName = attackName + "T-spin Single";
						break;
					case 2:
						attackName = attackName + "T-spin Double";
						break;
					default:
						attackName = attackName + "T-spin Triple";
						break;
				}
				if (b2b)
					score += 3*clearLineCount;
				else
					score += 2*clearLineCount;
			}
			b2b = true;

		} else {		// Double, Triple, Tetris
			if (clearLineCount == 4) {
				totalTetrises++;
				if (b2b)
					attackName = "B2B ";
				attackName = attackName + "Tetris";
				if (b2b)
					score += 6;
				else
					score += 4;
				b2b = true;
			} else {
				b2b = false;
				if (clearLineCount == 2)
					score += 1;
				else if (clearLineCount == 3)
					score += 2;
			}
		}

		if (pcCheck == 3600) {	// PC
			attackName = "Perfect Clear";
			score += 10;
		}

	}

	if ((clearLineCount > 0) || wasBomb) {	// combo count and scores
		combo++;
		if (combo > 1)
			totalCombos++;	//	don't sum combo = 1 (which isn't combo)

		if (combo > longestCombo)
			longestCombo = combo;
		if (((combo > 1) && (attackName == "") ||
				(match(attackName, "Combo") != null))
				|| (combo > 5))
			attackName = (combo-1) + " Combo";
		switch(combo) {
			case 0:	// shouldn't happen
				break;
			case 1: // no combo yet
				break;
			case 2: // 1 combo
				score += 1;
				break;
			case 3: // 2 combo
				score += 1;
				break;
			case 4: // 3 combo
				score += 2;
				break;
			case 5: // 4 combo
				score += 2;
				break;
			case 6: // 5 combo
				score += 3;
				break;
			case 7: // 6 combo
				score += 3;
				break;
			default:	// 7 and more combo
				score += 4;
				break;
		}
	} else
		combo = 0;
}

public void generateSequence() {	// fills index 7~13 of piece sequence
	// takes the first half of existing sequence and scramble it
	// for the second half
	int[] tmpList = new int[7];
	for (int i=0; i<7; i++) {
		tmpList[i] = pieceSequence[i];
	}

	int tmpCount = 7;
	for (int i=0; i<7; i++) {
		int j = PApplet.parseInt(random(tmpCount));	// take a random element of the list
		pieceSequence[i+7] = tmpList[j];// and put in piece sequence
		for (;j<tmpCount-1; j++){			// take out the element
			tmpList[j] = tmpList[j+1];
		}
		tmpCount--;
	}
}

public void nextPiece() {
	currentMino = pieceSequence[0];
	for (int i=0; i<14; i++) {
		pieceSequence[i] = pieceSequence[i+1];
	}
	if (pieceSequence[7] == 9)
		generateSequence();
}

public boolean isOccupied (int posX, int posY, int minoType, int minoRotation) {

	for (int i=0; i<4; i++) {
		int checkX = posX + tetromino[minoType][minoRotation][i][0];
		int checkY = posY + tetromino[minoType][minoRotation][i][1];
		if (checkX < 0 || checkX > 9 || checkY < 0 || checkY > 39)
			return true;
		else if (playField[checkX][checkY] != 9)
			return true;
	}
	return false;
}

public void bombRise(int pos) {
	
	// lift matrix up one row
	for (int i=0; i<10; i++) {
		for (int j=37; j>=0; j--) {
			playField[i][j+1] = playField[i][j];
		}
	}
	// add a garbage row
	for (int i=0; i<10; i++) {
		playField[i][0] = 7;
	}
	// add a bomb
	playField[pos][0] = 8;
	// if mino is on the bottom, lift that too
	if (isOccupied(currentX, currentY, currentMino, currentRotation)) {
		move(0, 1, false);
	}
}




String TEXT40L = "40 L";
String TEXT18B = "18 BOMBS";
String BOMBER = "BOMBER";
String PRACTICE = "PRACTICE";
String OPTIONS = "OPTIONS";

String SCORE = "Score";
String TIMEELAPSED = "Time Elapsed";
String PIECESDROPPED = "Pieces Dropped";
String GAMEOVER = "GAME OVER";
String PRESSENTER = "Press Enter to return";
String TOMAINMENU = "to the main menu";

String READY = "READY";
String LINESREMAINING = "Lines Remaining";
String AVERAGESPEED = "Average Speed";
String GOODJOB = "GOOD JOB!";

String RISERATE = "Rise Rate";
String TIME = "Time";
String SPEED = "Speed";
String LINESCLEARED = "Lines Cleared";
String BOMBSDETONATED = "Bombs Detonated";
String EFFICIENCY = "Efficiency";
String ATTACKPERMINUTE = "Attack Per Minute";
String ATTACKPERLINE = "Attack Per Line";

String TETRISES = "Tetrises";
String TSPINS = "T-Spins";
String TOTALCOMBOS = "Total Combos";
String LONGESTCOMBO = "Longest Combo";

String AUTOSHIFTDELAY = "Autoshift Delay";
String SONICDROP = "Sonic Drop";
String INSTANTMOVE = "Instant Move";
String MOVELEFT = "Move Left";
String MOVERIGHT = "Move Right";
String ROTATELEFT = "Rotate Left";
String ROTATERIGHT = "Rotate Right";
String ROTATE180 = "Rotate 180";
String HARDDROP = "Hard Drop";
String SOFTDROP = "Soft Drop";
String HOLD = "Hold";
String CLICKBOXSETSTO = "Click box sets to: ";

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "BombStepper" });
  }
}
